# Installing Enterprise Agents on Cisco Nexus Switches with Application Hosting

{% hint style="warning" %}
Due to recent platform-wide naming, navigation, and URL changes in the product, you may notice some discrepancies between the product and the screenshots displayed in our technical documentation. The instructions and actual pages in the product are still valid and haven’t changed. Please bear with us as we update our screenshots to better match the in-product experience. See the full scope of changes on [Naming and Navigation Menu changes - Summary List](https://docs.thousandeyes.com/whats-new/naming-and-nav-phase-2-changes).
{% endhint %}

This article covers the steps to install a ThousandEyes Enterprise Agent on supported Cisco Nexus switches using Cisco Application Hosting.

## Prerequisites

* A ThousandEyes account with permissions to install new agents. For more information on setting up a ThousandEyes account, see [Getting Started with Account Setup](https://docs.thousandeyes.com/product-documentation/getting-started/getting-started-with-account-setup).
* A supported Cisco Nexus switch. For more information on supported devices, see the [Nexus Switching Support Matrix](https://docs.thousandeyes.com/product-documentation/global-vantage-points/enterprise-agents/installing/cisco-devices).

{% hint style="warning" %}
The ThousandEyes for Government instance has additional requirements for Cisco Application Hosting installations. Refer to the [ThousandEyes for Government - FedRAMP® Moderate](https://docs.thousandeyes.com/product-documentation/thousandeyes-for-government#cisco-application-hosting) documentation for prerequisites and configuration requirements **before** continuing.
{% endhint %}

## Installation Instructions

1. Log into the ThousandEyes web application.
2. Navigate to **Network & App Synthetics > Agent Settings > Enterprise Agents > Agents**.
3. Click **Add New Enterprise Agent**.
4. In the pop out panel, navigate to **Cisco Application Hosting > Nexus Switches**.

   ![](/files/Qhpzh7DOgHplhyUwaFWX)

{% hint style="info" %}
The screenshot above shows a bridge configuration. For additional app-hosting configuration options, see the [Nexus Application Hosting documentation](https://www.cisco.com/c/en/us/td/docs/dcn/nx-os/nexus9000/103x/programmability/cisco-nexus-9000-series-nx-os-programmability-guide-release-103x/m-application-hosting.html).
{% endhint %}

## Download the TAR File

The TAR file can either be downloaded directly to the switch by using the NX-OS `copy` command, or downloaded via a web browser from the ThousandEyes webapp and then transferred to the Nexus switch:

{% hint style="info" %}
ThousandEyes recommends using the `copy` command if possible, as it reduces the download process to a single step, and will also verify access to *thousandeyes.com* from the switch.
{% endhint %}

{% hint style="info" %}
Depending on your network configuration, you may need to specify which VRF to use to reach *downloads.thousandeyes.com* as part of the `copy` command.
{% endhint %}

### Copy Command

1. In a terminal window on the Cisco Nexus switch, run the `copy` command shown in the ThousandEyes webapp to download the TAR file. It should look something like this:

   `copy https://downloads.thousandeyes.com/enterprise-agent/thousandeyes-enterprise-agent-VERSION.cisco.tar bootflash:`

{% hint style="warning" %}
If you encounter an error running the copy command, follow the instructions in [Browser Download](#browser-download) instead.
{% endhint %}

### Browser Download

1. From the **Cisco Application Hosting > Nexus Switches** screen, click the **Download - TAR** button.
2. In a terminal window, use SCP, FTP, TFTP, or USB storage to copy the TAR file to the switch's bootflash: directory. We recommend using the same method used to copy the NX-OS system software image onto the switch. For more information, see [Installing NX-OS](https://www.cisco.com/c/en/us/td/docs/dcn/nx-os/nexus9000/103x/upgrade/cisco-nexus-9000-nx-os-software-upgrade-downgrade-guide-103x/m_upgrading_or_downgrading_the_cisco_nexus_9000_series_nx-os_software_101x.html).

## Generate and Run Commands

1. From the **Cisco Application Hosting > Nexus Switches** screen, configure the required fields (and any optional ones you want) to generate the basic command structure for installing and starting the agent:

   ![](/files/25pUBYd3TzZmlK1xTZ6v)

   * **App ID**: The name used in the NX-OS CLI to manage the application hosting container.
   * **Bridge ID**: The number of the application hosting bridge instance created to connect the container to an L3 network on the switch. For more information, see [Configuring Application Hosting Bridge Connections](https://www.cisco.com/c/en/us/td/docs/dcn/nx-os/nexus9000/103x/programmability/cisco-nexus-9000-series-nx-os-programmability-guide-release-103x/m-application-hosting.html#task_rxd_45x_g5b).
   * **IP Address**: The IP address assigned to the interface inside the container.
   * **Agent Hostname (Optional)**: The hostname assigned to the agent within the container. By default, this is the same hostname as the switch.
   * **Name Server IP**: The DNS IP address used within the container.
   * **Gateway IP**: The default gateway IP address used within the container. This is usually the IP address of the application hosting bridge.
   * **Name Server IP 2 (Optional)**: An alternate DNS IP address.
2. Once the basic commands have been pre-configured, copy them from the web browser to a local machine.
3. Edit and expand the commands as necessary. Additional run-opts commands can be added as needed. For available commands, see [Docker Agent Configuration Options](https://docs.thousandeyes.com/product-documentation/global-vantage-points/enterprise-agents/installing/docker-agent-config-options).
4. Once the commands are ready, in a terminal window on the Nexus switch, run the commands in order from top to bottom, excluding the **copy** command.

## Limitations

* NX-OS version 10.3(3) and earlier does not support configuring multiple interfaces.

## Troubleshooting

#### NX-OS Copy Command Does Not Work With HTTPS

There is an existing bug that prevents the NX-OS `copy` command from working with HTTPS. This prevents users from downloading the ThousandEyes Enterprise Agent TAR file directly to the device.

**Workaround**

To workaround this issue, we recommend you download the TAR file, and then copy it to the switch using the same method used for copying the NX-OS system software image to the device.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.thousandeyes.com/product-documentation/global-vantage-points/enterprise-agents/installing/cisco-devices/installation-methods/installing-enterprise-agents-on-cisco-nexus-switches-with-application-hosting.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
